(height, percent, charge, low, lpm, m_color, b_color) {
	var canvas = document.createElement("canvas");
	canvas.height = height/2;
	canvas.width = height * (charge ? 1.65:1.2);
	var ctx = canvas.getContext("2d");
	
	var r = height / 12;
	var line_Width = 1;
	var p_Left = line_Width/2;
	var p_Right = height*1.1 - line_Width/2;
	var p_Top = line_Width/2;
	var p_Bottom = canvas.height - line_Width/2;
	var pi = Math.PI;
	var s = 1;
	s += line_Width ;

	ctx.beginPath();
	ctx.strokeStyle = "rgb(" + b_color.slice(0, 3).join()+ ")";
	ctx.lineWidth = line_Width;
	ctx.moveTo( p_Left+r, p_Top );
	ctx.lineTo( p_Right-r, p_Top );
	ctx.arc( p_Right-r, p_Top+r, r, -pi/2, 0, false);
	ctx.lineTo( p_Right,  p_Bottom-r );
	ctx.arc( p_Right-r, p_Bottom-r, r, 0, pi/2, false);
	ctx.lineTo( p_Left+r, p_Bottom);
	ctx.arc( p_Left+r, p_Bottom-r, r, pi/2, pi, false);
	ctx.lineTo( p_Left, p_Top+r);
	ctx.arc( p_Left+r, p_Top+r, r, pi, pi*3/2, false);
	ctx.closePath();
	ctx.stroke();

	ctx.beginPath();
	ctx.fillStyle = "rgb(" + b_color.slice(0, 3).join()+ ")";
	ctx.arc( p_Right+height/30, height/4, height/12, 0, pi*2, false);
	ctx.closePath();
	ctx.save();
	ctx.clip();
	ctx.fillRect( p_Right+height/20, 0, p_Right+height/10, p_Bottom);
	ctx.restore();

	ctx.beginPath();
	ctx.fillStyle = "rgb(" + b_color.slice(0, 3).join()+ ")";
	ctx.moveTo( height*1.2+height/6 + height/5, 0 );
	ctx.lineTo( height*1.2+height/6 + height/20*3, height/5 );
	ctx.lineTo( height*1.2+height/6 + height/20*5, height/5 );
	ctx.lineTo( height*1.2+height/6 + height/20*1, height/2 );
	ctx.lineTo( height*1.2+height/6 + height/20*2, height/4 );
	ctx.lineTo( height*1.2+height/6 + height/20*0, height/4 );
	ctx.closePath();
	ctx.fill();

	ctx.beginPath();
	ctx.fillStyle = "rgb(" + m_color.join()+ ")";
	ctx.lineWidth = line_Width;
	var rectWidth = (p_Right-p_Left-s*2) * percent / 100;
	ctx.moveTo( p_Left+r+s, p_Top+s );
	ctx.lineTo( p_Right-(r+s), p_Top+s );
	ctx.arc( p_Right-r, p_Top+r, r-s, -pi/2, 0, false);
	ctx.lineTo( p_Right-s,  p_Bottom-(r+s) );
	ctx.arc( p_Right-r, p_Bottom-r, r-s, 0, pi/2, false);
	ctx.lineTo( p_Left+(r+s), p_Bottom-s);
	ctx.arc( p_Left+r, p_Bottom-r, r-s, pi/2, pi, false);
	ctx.lineTo( p_Left+s, p_Top+(r+s));
	ctx.arc( p_Left+r, p_Top+r, r-s, pi, pi*3/2, false);
	ctx.closePath();
	ctx.clip();
	ctx.fillRect( p_Left+s, 0, rectWidth, p_Bottom);

    return canvas.toDataURL("image/png");
}
